#!/usr/bin/env python
# coding: utf8
# (c) 2014 Dominic Springer
# This file is licensed under the 2-Clause BSD License (see HARP_License.txt)

import sys
import __builtin__

#sys.path.append(LibDir) 

from Imports_Basic import *
from OpenCV import *
from Sequence import *
from External import configobj

PRECISION = np.float64
import inspect
import StringIO
#from profilehooks import profile

#==========================================
def testfunc():
#========================================== 

    print "Running testfunc"
    current_module = sys.modules[__name__]
    print "Current module:", current_module
    
    #print "__dict__:\n", str(current_module.__dict__)
    #print "__dict__.__builtins__:\n", str(current_module.__dict__["__builtins__"])
    
    test = current_module.__dict__["__builtins__"]
    #print "__dict__.__builtins__.__builtin__:\n", str(current_module.__dict__["__builtins__"].__builtin__)
    
    #print str(__builtins__)
    print "ProjectDir: ", ProjectDir
    print "Cnt1:" , Cnt1
    
    #__builtins__["Cnt1"] += 1  # works perfectly
    
    return True
    
#==========================================
def init_HARP():
#==========================================

    print "Initializing HARP:"
    print "HARP main dirs:"
    print "ProjectDir: " + ProjectDir
    #print "LibDir: " + LibDir
    print "TmpDir: " + TmpDir

    #ADDING GLOBAL VARS
    if not __builtins__.has_key("INI"):
        FN = HARP_ProjectDir + "/" + "HARP_Settings.ini"
        assertFileExists(FN)
        print "Loading INI: ", FN
        from External import configobj
        __builtins__.update(INI = configobj.ConfigObj(FN))

    
    SequFN = InputYUV
    Sequ = Sequence(SequFN, Fr=-1, FPS=30)
    
    __builtins__.update(Sequ = Sequ)
    __builtins__.update(df = {})
    
    print 'InputYUV (builtins): ', InputYUV
    print 'Sequ (builtins): ', Sequ
    print 'INI (builtins): ', INI
    print 'Sequ Alias: ', Sequ.Alias
    
    print "Python PID: ", os.getpid()
    
    import thread
    import time
    import psutil 
    import pandas
    import matplotlib.pyplot
    import datetime
    
    if int(INI["HARP"]["LogRam"])  == True:
        start_Ram_Log(os.getpid(), TmpDir + "/RamLog.xlsx")

#==========================================       
def postprocess_POC(HDT_FN):    
#==========================================  
   
    print "Analyzing HDT: " + HDT_FN
    CompareDepth = int(INI["Visualization"]["CompareDepth"])
    CompareSize  = str(INI["Visualization"]["CompareSize"])
    Call = ProjectDir + "/Scripts/a_analyze_HDTs.py %s %s %s" % (HDT_FN, CompareDepth, CompareSize)
    # HACK disabled for now
    #runCall(Call)
        
#==========================================       
def close_HARP():    
#==========================================    
    if int(INI["HARP"]["LogRam"]) == True:
        stop_RAM_Log()

#==========================================
def INI_load_INT(Section, Option):
#========================================== 
    return int(INI[Section][Option])    

#==========================================
def INI_load_INTLIST(Section, Option):
#========================================== 
    INTLIST = [int(i) for i in INI[Section][Option] ]
    #print "INTLIST:", INTLIST
    return INTLIST  

#==========================================
def INI_load_STR(Section, Option):
#========================================== 
    return str(INI[Section][Option])    

#========================================== 
def INI_save(Section, Option, Value):
#========================================== 
    INI[Section][Option] = str(Value)  #always save as string
    return True
    
#========================================== 
def is_HDT_POC(POCIdx):
#==========================================    
    HDT_POCs = [int(i) for i in INI['HARP']['HDT_POCs'] ]
    if POCIdx in HDT_POCs:
        return True
    else: return False
    
#========================================== 
def is_VisRDO_CTU(CTUIdx):
#==========================================    
    VisRDO_CTUs = [int(i) for i in INI['Visualization']['VisRDO_CTUs'] ]
    if CTUIdx in VisRDO_CTUs:
        return True
    else: return False
    

    

    




    
