#!/usr/bin/env python
# coding: utf8
# (c) 2014 Dominic Springer
# This file is licensed under the 2-Clause BSD License (see HARP_License.txt)

from Imports_Basic import *
from Numpy import *
print "Python version: ", sys.version
#from Motion.wrapper_bgslibrary.bgslibrary import *
#import Motion.wrapper_bgslibrary.bgslibrary

#==========================================================================================================================
#====================================================  TEMPLATES   ========================================================
#==========================================================================================================================

#==========================================
# CHANGE HERE
#==========================================
#...
#==========================================

#================================
# ENCRYPT / DECRYPT
#================================
# MYDIR=10_April
# tar -zcvf - $MYDIR | openssl enc -aes-256-cbc -salt -k XXX | dd of=$MYDIR.enc
# dd if=$MYDIR.enc | openssl aes-256-cbc -d -k XXX | tar -C ./ -zxvf -

#================================
# CORE TMP DIR REDIRECT
#================================
# Redirect the TmpDir (if you like):
# __builtins__.CoreTmpDir       = "/any/path/you/like"
# __builtins__.update(CoreTmpDir = "/any/path/you/like" )

#================================
# LAST ELEMENT OF LIST
#================================
if 0:
    some_list[-1]
    
#================================
# SIMPLE FILE/DIR LISTS (magic: .split("\n")[:-1])
#================================
if 0:
    
    FNs = \
"""
/home/dom/index.html
/home/dom/testdisk.log
""".split("\n")[1:-1]
    
#================================
# CHARACTER TESTS
#================================   
if 0: # BTS: works also on strings
    "a".isalpha() #letters, not numbers
    "a1".isalnum() #letters and numbers, nothing else
    "1".isdigit() #only numbers
    #floats need to be caught by regex

# ▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀
# TEMPLATE FOR NEW SCRIPTS
# ▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀
if 0:
    
    #!/usr/bin/env python
    #coding: utf8
    import sys, os
    CoreDir = os.path.realpath(os.path.dirname(os.path.realpath(__file__)) + "/..") # CHANGE HERE
    sys.path.extend([CoreDir ,])
    assert "HARP_Core" == os.path.split(CoreDir)[1], "Not CoreDir: " + CoreDir
    from Imports_Basic import *
    set_HARP_Core_Environment(CoreDir, __name__)

    #==========================================
    def main():
    #==========================================    
        pass
        
    #==========================================
    if __name__ == '__main__':
    #==========================================       
        main()
        print "Done"

# template for Class
#|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
class ClassTemplate(object):
#|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
    #==========================================
    def __init__(self):
    #==========================================
        super(ClassTemplate, self).__init__()
        # CHANGE HERE -------------------------------------------------
        # -------------------------------------------------------------
        class CAnyClass:
            pass
    #==========================================
    def run(self):
    #==========================================
        #-------------------------------------
        # COMMENT
        #-------------------------------------
        pass

#================================
# NAMED TUPLES
#================================
if 0:
    Setups = []
    SetupNT = collections.namedtuple('NTuple', 'Switch1 Switch2')
    Setups.append( SetupNT(Switch1="On", Switch2="Off") )

#==========================================
def get_Setup_Alias(Setup):
#==========================================
    #iterate through fields:
    str = ""
    for name in Setup._fields:
        value = getattr(Setup, name)
        str += "%s " % value
    str = str.strip()
    return str 

# ▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄
# Special Plot Export
# ▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄▀▄
# General rule: use Messung-PNGS!!
# If REALLY necessary: save Data.cpkl, reload (some work!)




#==========================================
# BEAUTIFUL ONE-LINERS, ONELINERS
#==========================================
if 0:
    UserSysPath = [ent for ent in sys.path if "/usr/" not in ent ]
    print "SysPath= ", "\n".join(UserSysPath)


# X FOR X IN Y:    TypeConverted = [float(i) for i in lst]
# X FOR X IN Y:    PNGs = [PNG for PNG in PNGs if "_002_" not in PNG]
# X FOR X IN Y:    Types = [type(Number) for Number in RES[key][:] if Number != None]    
# CONVERT ROW AND COL TO INDEX, COL FIRST: Images[c*rows + r] 
# CONVERT ROW AND COL TO INDEX, ROW FIRST: Images[r*cols + c]
    
#==========================================
# CLASS DECLARATION
#==========================================
class EmptyClass(object):
    pass

#==========================================
# TRY EXCEPT | No argument passing required!
#==========================================
if 0:
    try:
        assert(0)
    except:        
        printException()
        raise #optional
#===============================
def printException():
#===============================
    #print "STR:\n", Str #NOT REQUIRED, CONTAINED BELOW
    print "ESC_INFO:\n", sys.exc_info()[0:3] #COMPACT+RAW, EXCELLENT FOR UNICODE DEBUGGING
    print "TRACEBACK:\n",traceback.print_tb(sys.exc_info()[2]) #NOT REQUIRED, RAISE WILL HANDLE, ONLY USE WHEN NOT RAISING ("IGNORE ERROR")
    

#==========================================
# READING AND WRITING GLOBALS
#==========================================
# NOTE: a declaration of globvar at global context seems not necessary!!
#globvar = 0
def set_globvar_to_one():
    global globvar    # Needed to modify global copy of globvar
    globvar = 1

def print_globvar():
    print globvar     # No need for global declaration to read value of globvar

#==========================================
# UNPACK / UNROLL / SPLAT / ASTERISK OPERATOR **
#==========================================
# always in FRONT!

# Python name: unroll, Perl name: splat
# Example 1: function(*args)
# Example 2: def enum(*sequential, **named):  (SEE BELOW)
# Example 3: 

#==========================================
# INDEXING
#==========================================
if 0:
    Test = "myfile.py"
    print Test[:-3] # remove ".py"
    print Test[-1] # returns "y"
    print Test[::-1] # reverse! reverse array. invert array.
    #ALSO SEE NUMPY INDEXING
    
    #find index of element in list
    ["foo", "bar", "baz"].index("bar")
    
#===============================
def set_CoreTmpDir(NewDir):
#===============================
    # SETTING BUILTINS: strange syntax, first name, then "=", then value. Name not as a string.
    #__builtins__.CoreTmpDir = NewDir # doesn't work because of stack depth
    __builtins__.update(PREVIOUS_CoreTmpDir = CoreTmpDir)
    __builtins__.update(CoreTmpDir = NewDir)
    createDir(NewDir)

#===============================
def restore_CoreTmpDir():
#===============================
    __builtins__.update(CoreTmpDir = PREVIOUS_CoreTmpDir)
    

#==========================================================================================================================
#===============================================  "RES" ENLISTING  ========================================================
#==========================================================================================================================

# copy from a subres with single entries to a RES with lists
#==========================================
def enlist_Object(RES, ListName, Obj): # APPEND TO LIST
#==========================================
    # add a value to a list inside a given dict, create list if it doesn't exist
    List_inRES = RES.setdefault(ListName, []) # get list in RES (create if necessary)
    List_inRES.append(Obj)
    
#deprecated, remove
# as above, but for ALL keys in subres
# copy from a subres with single entries to a RES with lists
#==========================================
def enlist_COPY_FROM_TO(Dict_Src, Dict_Dst): 
#==========================================
    return enlist_SRES_to_LRES(Dict_Src, Dict_Dst)

#==========================================
def enlist_SRES_to_LRES(SRES, LRES): #SRES: single entries in a dict, LRES: a dict of list, where SRES is "fanned out"
#==========================================
    #MAKE SURE YOU ASSERT RETURN VAL TO RES!!
    #SUPERSTRANGE. If "return" is not used, values go to nirvana. Likely a "reference cnt" problem. Not sure.
    IDs = SRES.keys()
    for ID in IDs:
        Obj = SRES[ID]
        if ID in LRES:
            assert type(LRES[ID]) == list, "ID=%s" % ID #if already there: must be a list
        enlist_Object(LRES, ID, Obj)  
    return LRES  

#OLD, REMOVE
#==========================================
def enlist_Objects(Dict_Src, Dict_Dst, IDs):
#==========================================
    for ID in IDs:
        Value = Dict_Src[ID]
        List = Dict_Dst.setdefault(ID, []) # get list (create if necessary)
        List.append(Value)  
    
#==========================================================================================================================
#================================================   DICTS / LISTS  ========================================================
#==========================================================================================================================

#==========================================
def compareDicts(dict1, dict2): #check if dicts are equal
#==========================================
    return dict1 == dict2 #simple as that! Python FTW!

#==========================================
def existsAttribute(obj, AttributeName):
#==========================================
    return hasattr(obj, AttributeName)

#==========================================
def dm(d1, d2):
#==========================================
    # merge two dicts into one
    d3 = d1.copy()
    d3.update(d2)
    return d3

#==========================================
def example_instantiate_Dict():
#==========================================
    # dictionary initialization (first is more "pythonic")
    a = { 'a': 'value',    'another': 'value' }
    
    b = {
        'a': 'value',
        'another': 'value',}
    
    # DONT USE
    c = dict( 
        a='value',
        another='value',)

#==========================================
def reverse_List(List):
#==========================================
    return List[::-1] #interesting! Like L[1:10:-1], the -1 turns the count direction!

#==========================================
def get_Object_Matrix(rows, cols): #address with Matrix[1][2]
#==========================================
    Matrix = [[None] * cols for i in range(rows)]
    return Matrix

#==========================================
def flatten_List_of_Lists(axarr):
#==========================================       
    #nice for flattening axarr's
    import itertools
    return itertools.chain(*axarr)

#==========================================
def getCommaStringFromList(List):
#==========================================    
    return (','.join(str(i) for i in List))

#==========================================
def join(StrList):
#==========================================   
    return '_'.join(StrList)

#==========================================
def mergeDicts(DictA, DictB, PrefixA, PrefixB):
#==========================================
    CopyA = DictA.copy()
    CopyB = DictB.copy()
    for key in CopyA.keys():
        CopyA[PrefixA + key] = CopyA.pop(key)
    for key in CopyB.keys():
        CopyB[PrefixB + key] = CopyB.pop(key)
    CopyA.update(CopyB)
    return CopyA

#==========================================
def convert_Dict_To_List(Dict, SortedLabels):
#==========================================
    # helpfull for plotting of bars
    # convert a dict with n named values to one lists with n values, and another list with the names
    List = []
    for Label in SortedLabels:
        List.append(Dict[Label])
    return List

#unused
# ============================
def invertDict(Dict):
# ============================
    inv_map = {v: k for k, v in map.items()}
    return inv_map

#==========================================
def print_Dict_Content(MyDict, Name):
#==========================================
    # ==================
    def parseList(MyList, Name, depth):
    # ==================
        depth += 1
        print (depth * '\t') + "======== %s ========" % Name
        
        for Idx, Object in enumerate(MyList):
            
            ObjectType = type(Object)  
            Key = "%s[%d]" % (Name, Idx)
                
            if ObjectType is types.ListType:
                print (depth * '\t') + "Entry %s is a list (%d entries)"  % (Key, len(Object))
                parseList(Object, Key, depth) # key gives the name

            elif ObjectType is types.DictType:
                print (depth * '\t') + "Entry %s is a dict"  % Key
                parseDict(Object, Key, depth) # key gives the name
   
            elif  ObjectType is np.ndarray: 
                #MyDict[Key] = "ndarray"  #DELETE, FOR XML
                print (depth * '\t') + "Entry %s is an ndarray" % Key
                #
                
            elif  ObjectType is int: 
                print (depth * '\t') + "Entry %s is an int" % Key
                
            elif  ObjectType is str: 
                print (depth * '\t') + "Entry %s is a string" % Key
                
            elif  ObjectType is tuple: 
                print (depth * '\t') + "Entry %s is a tuple" % Key
            else:
                assert(0), "Entry \"%s\" is unknown, type: %s"  % (Key, ObjectType)
        
    # ==================
    def parseDict(MyDict, Name, depth):
    # ==================
        depth += 1
        print (depth * '\t') + "======== %s ========" % Name
        
        for Key in MyDict.keys():
            
            Object = MyDict[Key]
            ObjectType = type(Object)  
                
            if ObjectType is types.ListType:
                print (depth * '\t') + "Entry %s is a list (%d entries)"  % (Key, len(Object))
                parseList(Object, Key, depth) # key gives the name

            elif ObjectType is types.DictType:
                print (depth * '\t') + "Entry %s is a dict"  % Key
                parseDict(Object, Key, depth) # key gives the name
   
            elif  ObjectType is np.ndarray: 
                #MyDict[Key] = "ndarray"  #DELETE, FOR XML
                print (depth * '\t') + "Entry %s is an ndarray" % Key
                #
                
            elif  ObjectType is int: 
                print (depth * '\t') + "Entry %s is an int" % Key
                
            elif  ObjectType is str: 
                print (depth * '\t') + "Entry %s is a string" % Key
                
            elif  ObjectType is tuple: 
                print (depth * '\t') + "Entry %s is a tuple" % Key
            else:
                assert(0), "Entry \"%s\" is unknown, type: %s"  % (Key, ObjectType)
                
    parseDict(MyDict, Name, -1)

# USE:
# Dict_Browser().show(MyPOC)
# ACCEPTS: objects and filenames (easy!)
from traits.api import HasTraits, Instance
from traitsui.api import View, VGroup, Item, ValueEditor
#|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
class Dict_Browser(HasTraits): #ShowDict, show dict
#|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
    #=========================    
    def __init__(self):
    #=========================
        super(Dict_Browser, self).__init__()
        
    #=========================    
    def trait_view(self, name=None, view_elements=None):
    #=========================
        MyGroup = VGroup(Item( 'Dict',
                  label      = 'HARP\nData\nTree\n(HDT)',
                  show_label = True,
                  style      = 'simple',
                  dock       = 'horizontal',
                  editor     = ValueEditor(),),)
        return View(
          MyGroup, title = "Title", width = 1280, height = 800, resizable = True)

    #=========================  
    def show(self, Unknown):
    #=========================  
        # String? -> FN
        if type(Unknown) == type(str()): 
            FN = Unknown
            if ".cpkl" in FN or ".hdt" in FN:
                self.Dict = load_CPickle_FN(FN)
                self.configure_traits()
            elif ".pkl" in FN:
                self.Dict = load_Pickle_FN(FN)
                self.configure_traits()
            else: assert(0)
        else: # or Dict? List?
            self.Dict = Unknown
            self.configure_traits()
            
# ALIASES
def show_Object(Obj):
    Dict_Browser().show(Obj)
def show_object(Obj):
    Dict_Browser().show(Obj)
def showObject(Obj):
    Dict_Browser().show(Obj)
def SHOW(Obj):
    Dict_Browser().show(Obj)
    
#==========================================================================================================================
#!======================================================  STRINGS  ========================================================
#==========================================================================================================================

# translate a list or single str, from a sparse "tr-LUT"
#==========================================
def TR(Str_or_StrList, tr_LUT):
#==========================================  
    if type(Str_or_StrList) == list or type(Str_or_StrList) == tuple:
        StrList = Str_or_StrList
        RetList = []
        for str in StrList:
            if str in tr_LUT:
                RetList.append(tr_LUT[str]) #translate
            else: 
                print str
                RetList.append(str) #not found, copy over
        return RetList
    else: 
        str = Str_or_StrList
        if str in tr_LUT:
            RetStr = tr_LUT[str]
        else: RetStr = str
        return RetStr
        
#==========================================
def raw_Strings_EXAMPLE1():
#==========================================   
    # NOTE: we simply declare a multiline string.
    # Since its a raw string, no backslashes get touched. ALSO: Dollar-S remains!
    # Oh yes man. Oh yes.
    
    header = \
r"""
\begin{tabular}{|>{\centering\arraybackslash\advance\hsize6em}X|Y|Y|Y|Y|Y|Y|}
\toprule
%s
\toprule
""" 
    print header % "HELLO WORLD"
    
#==========================================
def raw_Strings_EXAMPLE2():
#========================================== 
    #NOTE: row += r" \\" will append this string unchanged to the other!! Oh yes man.
    Entries = ( "GT-BGS" , "No-BGS" )
    row =  " & ".join(Entries)
    row += r" \\"
    print row 


#==========================================
def combine(*Strings):
#==========================================    
    Res = ""
    for Str in Strings:
        Res += Str + "_"
    return Res[:-1] #-1: chop last element

#==========================================
def split_String(Str, Token = "\n"): #NOT IN PLACE! splitstring
#==========================================    
    return Str.split(Token) 

#==========================================
def strip_Whitespaces_Newlines(s): #NOT IN PLACE! 
#==========================================
    return s.strip() #trim whitespaces an newlines on BOTH left and right (also removes \t)
    #use s.rstrip() / s.lstrip() for left and right 
    #OPTIONAL: pass '\n' to only strip newlines
    
#==========================================
def replace_in_String(str, old, new): #NOT IN PLACE! 
#==========================================   
    return str.replace(old, new)

#==========================================
def add_String_Lists_Elementwise(list1, list2): #NOT IN PLACE! 
#==========================================   
    return ["%s_%s" % (a,b) for a,b in zip(list1, list2)] # woa, a beauty! Python to the rescue! :)


# Perfectly invertible:
#========================
def text2lines(text): #restricted to newline! TBD: add arbitray separator
#========================    
    #Agreement: always keep newlines at end. Otherwise, reconstruction from text to lines is no longer possible!
    #lines = text.split("\n") #WARNING: split removes token! 
    lines = text.splitlines(True) #split on newline, keep newline at end
    return lines

#========================
def lines2text(lines): #not restricted to newline!
#======================== 
    text = ""
    for idx, line in enumerate(lines):
        text += line
    return text

#==========================================================================================================================
#!================================================   PKL IMPORT EXPORT  ===================================================
#==========================================================================================================================

# Note: SAVE/LOAD always needs to make distinction
# Idea: define own format ".xpkl", plus SAVE and LOAD, which handles variants transparently on its own


# INSTANTLY SAVE A PKL FILE
# savePickleFN(PU, TmpDir + "/test_PU.pkl")
# savePickleFN(CU, TmpDir + "/test_CU.pkl")
# savePickleFN(CTU, TmpDir + "/test_CTU.pkl")

#==========================================
def SAVE(Object, FN):
#==========================================
    if FN.endswith(".pkl"):
        save_Pickle_FN(Object, FN)
    elif FN.endswith(".cpkl"):
        save_CPickle_FN(Object, FN)
    elif FN.endswith(".json"):
        save_Json_FN(Object, FN)
    print "SAVED PKL:" + FN 

#==========================================
def LOAD(FN):
#==========================================
    if FN.endswith(".pkl"):
        Object = pickle.load(open(FN, "rb" ) )
    elif FN.endswith(".cpkl"):
        Object = cPickle.load(open(FN, "rb" ) )
    elif FN.endswith(".cpkl"):
        Object = load_Json_FN(FN)
    #print "LOADED PKL:" + FN 
    return Object
    
#==========================================
def save_Pickle_FN(Object, FN, silent=False):
#==========================================
    assert FN.endswith(".pkl"), "False file type: " + FN
    pickle.dump( Object, open(FN, "wb" ), protocol=2 )
    if not silent: print "PICKLE saved: " + FN
        
#==========================================
def load_Pickle_FN(FN, silent=False):
#==========================================
    assertFileExists(FN)
    assert FN.endswith(".pkl"), "False file type: " + FN
    Object = pickle.load(open(FN, "rb" ) )   
    if not silent: print "PICKLE loaded: " + FN
    return Object

#==========================================
def save_CPickle_FN(Object, FN, silent=False):
#==========================================
    #import cPickle
    assert FN.endswith(".cpkl") or FN.endswith(".hdt"), "False file type: " + FN
    cPickle.dump( Object, open(FN, "wb" ), protocol=2 )
    if not silent: print "CPICKLE saved: " + FN


#HJSON: human readable json
#==========================================
def save_HJSON_FN(Object, FN, silent=False):
#==========================================
    import hjson
    assert FN.endswith(".hjson")
    
    text = hjson.dumps(Object) # == encode
    writeTXT(text, FN)
    if not silent: print "HJSON saved: " + FN  

#==========================================
def load_HJSON_FN(FN, silent=False):
#==========================================
    import hjson
    assert FN.endswith(".hjson")
    assert exists(FN)
    Object = hjson.loads(readTXT(FN)) # == decode
    
    if not silent: print "HJSON loaded: " + FN  
    return Object



#USE THIS!
#==========================================
def save_JSON_FN(Object, FN, silent=False):
#==========================================
    import jsonpickle
    assert FN.endswith(".json")
    
    jsonpickle.set_encoder_options('simplejson', sort_keys=True, indent=4)
    String = jsonpickle.encode(Object)
    #f = codecs.open(FN, "w", encoding="utf-8")
    #String = json.dumps( Object, indent = 0)
    writeTXT(String, FN)
    if not silent: print "JSONPICKLE saved: " + FN    
    
#USE THIS!
#==========================================
def load_JSON_FN(FN, silent=False):
#==========================================
    import jsonpickle
    assert FN.endswith(".json")
    assert exists(FN)
    #Obj = jsonpickle.decode(open(FN, "r").read()) # inherent UTF-8 bug danger!
    Obj = jsonpickle.decode(readTXT(FN))
    readTXT
    if not silent: print "JSONPICKLE loaded: " + FN  
    return Obj

#deprecated, only default types
#==========================================
def save_Json_FN(Object, FN, silent=False):
#==========================================
    import json
    assert FN.endswith(".json")
    #f = codecs.open(FN, "w", encoding="utf-8")
    String = json.dumps( Object, indent = 0)
    writeTXT(String, FN)
    #f.close()
    if not silent: print "JSON saved: " + FN
    
#deprecated, onl default types
#==========================================
def appendTo_Json_FN(Object, FN, silent=False):
#==========================================
    import json
    assert FN.endswith(".json")
    #f = codecs.open(FN, "w", encoding="utf-8")
    String = json.dumps( Object, indent = 0)
    writeTXT(String, FN)
    #f.close()
    if not silent: print "JSON saved: " + FN
    
#deprecated, onl default types
#==========================================
def load_Json_FN(FN, silent=False):
#==========================================  
    import json
    assert FN.endswith(".json")
    String = readTXT(FN)
    Object = json.loads(String)
    if not silent: print "JSON loaded: " + FN
    return Object

#==========================================
def load_CPickle_FN(FN, silent=False):
#==========================================
    #import cPickle
    assertFileExists(FN)
    assert FN.endswith(".cpkl") or FN.endswith(".hdt"), "False file type: " + FN
    Object = cPickle.load(open(FN, "rb" ) )   
    if not silent: print "PICKLE loaded: " + FN
    return Object
 
#==========================================   
def analyzePickleFN(FN, ID):
#==========================================
    import GraphViz
    NameRootNode = ID
    obj = loadPickleFN(FN)
    prettyprint(obj, ID, "%s.txt" % ID)
    GraphViz.draw_Dict(obj, ID,  "%s.png" % ID)
    
#==========================================
def save_Pickle_FN_Compressed(Object, FN):
#==========================================
    print "Saving compressed PKL... ",
    assert FN.endswith(".pkl"), "False file type: " + FN
    pklz = gzip.GzipFile(FN, 'wb')
    pklz.write(pickle.dumps(Object, protocol=0))
    pklz.close()
    print "done"
    
#==========================================
def load_Pickle_FN_Compressed(FN):
#==========================================
    assertFileExists(FN)
    assert FN.endswith(".pkl"), "False file type: " + FN
    pklz = gzip.GzipFile(FN, 'rb')

    Buffer = ""
    while True:
        data = pklz.read()
        if data == "":
            break
        Buffer += data
    Object = pickle.loads(Buffer)
    pklz.close()
    return Object

#==========================================
def save_Marshal_FN(Object, FN, silent=False):
#==========================================
    marshal.dump( Object, open(FN, "wb"))
    if not silent: print "MARSHAL saved: " + FN
    
#==========================================
def load_Marshal_FN(FN, silent=False):
#==========================================
    assertFileExists(FN)
    if not silent: print "Starting to load marshal ..." 
    Object = marshal.load(open(FN, "rb" ) )   
    if not silent: print "MARSHAL loaded: " + FN
    return Object

#==========================================================================================================================
# ===================================================   INI STUFF   =======================================================
#==========================================================================================================================

#DUPLICATE, no longer needed
# #==========================================
# def make_INI_Global():
# #==========================================    
#     if not __builtins__.has_key("INI"):
#         FN = ProjectDir + "/" + "HARP_Settings.ini"
#         assertFileExists(FN, "INI not found")
#         print "Loading INI: ", FN
#         from External import configobj
#         __builtins__.update(INI = configobj.ConfigObj(FN))

#-
# DEPRECATED OBJECTPARSER STUFF

# CURRENTLY NEED THE load_INI for VP9/X265 INSTALLER
# configobj.ConfigObj IS NOT WORKING SINCE CONFIGOBJECT DOES NOT ALLOW KEYS WITHOUT VALUE

#==========================================
def load_INI_old(FN):
#==========================================      
    assertFileExists(FN)
    Config = ConfigParser.ConfigParser(allow_no_value=True) # allow keys without values
    Config.optionxform = str #preserve upper/lower case
    LinesRead = Config.read(FN)
    assert (len(LinesRead) == 1)
    return Config
    # then access by self.Config.get(Section, Arg)
    
# #==========================================
# def INI_load_INT(Section, Option):
# #========================================== 
#     return int(INI.get(Section, Option))    
# 
# #==========================================
# def INI_load_STR(Section, Option):
# #========================================== 
#     return str(INI.get(Section, Option))   
#  
# #========================================== 
# def INI_save(Section, Option, Value):
# #========================================== 
#     INI.set(Section, Option, str(Value))  #always save as string
#     return True
#-

#==========================================================================================================================
#====================================================   PRINTING  =========================================================
#==========================================================================================================================

#==========================================
def printCOLOR(string, color="green"):
#==========================================
    import pyfiglet
    import termcolor

    #remove last line (empty)
    RenderedText = pyfiglet.Figlet().renderText(string)
    RenderedText = RenderedText.split("\n")
    RenderedText = RenderedText[:-1]
    RenderedText = "\n".join(RenderedText)
  
    termcolor.cprint("# =================================================", color)
    termcolor.cprint(RenderedText, color),
    termcolor.cprint("# =================================================", color)

#==========================================
def initPrintOptions():
#==========================================
    np.set_printoptions(precision = 6)
    np.set_printoptions(linewidth = 120)
    np.set_printoptions(suppress=True)
 
#==========================================   
def printLarge(Str, Level=0):
#==========================================
    printLARGE(Str, Level)
    
#==========================================
def printLARGE(Str, Level=0):
#==========================================
   LARGE_Header = getSectionHeader(Str, Level=Level)
   print LARGE_Header,
    
#==========================================
def getSectionHeader(Str, Level=0, StartSymbol = "#", BarSymbol = "="):
#========================================== 
    LookupTable = { -2 : 120, -1 : 100, 3:15, 2 : 30, 1: 60, 0: 80}
    Length = LookupTable[Level]
    Str = StartSymbol + " " + Str + " " * (Length - len(Str))
    Str = "\n" + StartSymbol + BarSymbol*Length + "\n" + Str + "\n" + StartSymbol + BarSymbol*Length + "\n"
    return Str

#==========================================
def PRINTLARGE(*arg): #alternative spelling
#==========================================
    printLARGE(*arg)
    
#==========================================
def printPERCENT(Idx, Total):
#==========================================
    Percent = (float(Idx+1))/Total * 100
    print "\r%d percent done" % Percent,
    sys.stdout.flush()    
    
#==========================================
def show_Message_Box(Text):
#==========================================    
    import easygui
    easygui.msgbox(Text, title="ATTENTION")

#==========================================
def printWARNING(Text):
#==========================================
    print cmdcolor.BRed + "WARNING: " + Text + cmdcolor.End
    #print colored('hello', 'red'), colored('world', 'green')
        
#==========================================
def printHistory():
#==========================================
    import readline
    for i in range(readline.get_current_history_length()):
        print readline.get_history_item(i)    
        
#==========================================
def prettyprint_Dict(Object, ID="Dict", FN_out=None): #or any object
#==========================================    
    import pprint
    print "print_Dict: printing " + ID 
    pp = pprint.PrettyPrinter(indent=4)
    pp.pprint(Object)
    if (FN_out != None):
        with open(FN_out, 'wt') as out:
            pprint.pprint(Object, stream=out)
    print "print_Dict: done\n"
    return "%s:\n" % ID + pprint.pformat(Object) #to string, too

#==========================================
def prettyprint(AnyObject):
#==========================================
    pprint(AnyObject)

#==========================================
def pprint(AnyObject):
#==========================================
    import pprint
    pp = pprint.PrettyPrinter(indent=4)
    #print "Prettyprint:"
    pp.pprint(AnyObject)


#==========================================================================================================================
#============================================== UNICODE =======================================================
#==========================================================================================================================
  
#================================
# UNICODE
#================================
if 0:
    teststr = u"diﬃcult"
    print repr(teststr)
    sys.exit()
    
    print u"myteststr" + u'\u2013'
    print uc2str_showNonASCII()
    print uc2str_ASCII()
    
# MOST IMPORTANT
#==========================================
def cast_utf8str_2_unicode(String):
#==========================================
    return String.decode("utf-8") #reas as: "decode, assuming utf-8 format"

# MOST IMPORTANT
#==========================================
def cast_unciode_2_utf8str(uc):
#==========================================
    return uc.encode("utf-8") #reas as: "encode using utf-8 format"

#use:
#except UnicodeDecodeError as ude: 
#    debugUnicode(string, ude.start )
#==========================================
def debugUnicode(String, pos):
#==========================================
    print "Unicode problem (> <):"
    print "Default: " + String[pos-10:pos] + ">" + String[pos] + "<" + String[pos+1:pos+10]
    print "Repr: " + repr(String[pos-10:pos]) + ">" + repr(String[pos]) + "<" + repr(String[pos+1:pos+10])

#==========================================
def sanitize_FAT32(FN = u"AnyFileFN / / ?öö myteststr" + u'\u2013'):
#==========================================
    #SUPPLY ONLY FILENAME WITHOUT PATH!

    import string
    valid_chars = "-_.() %s%s" % (string.ascii_letters, string.digits)
    # '-_.() abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'
        
    NewFN = []
    for c in FN:
        if c in valid_chars:
            NewFN.append(c)
        else: NewFN.append(" ")
    NewFN = ''.join(NewFN)

    #we may have left some spaces. Correct this.
    NewFN = re.sub(' +',' ', NewFN) #only leave single whitespaces
    NewFN = NewFN.rstrip(" ")
    return NewFN
    
    #NICE ONE, BUT NEED TO EXTEND "ELSE": Title = ''.join(c for c in Title if c in valid_chars)
    #READ TO SIMPLIFY:
    #http://stackoverflow.com/questions/17321138/python-one-line-list-comprehension-if-else-variants
        
#==========================================
def isUC(anyobj = u"myteststr" + u'\u2013'):
#==========================================
    return isinstance(anyobj, unicode)
    
#==========================================
def uc2str_ASCII(uc = u"myteststr" + u'\u2013'):
#==========================================
    return str(uc.encode('ascii', 'ignore')) #non-ascii will simply disappear
    
#==========================================
def uc2str_showNonASCII(uc = u"myteststr" + u'\u2013'):
#==========================================
    #BETTER ALTERNATIVE: use repr()!
    return str(uc.encode('raw_unicode_escape'))
        
#==========================================================================================================================
#=================================================== PATHES SWISSKNIFE ====================================================
#==========================================================================================================================



#PURE!
#==========================================
def getPureDIR(AFN): # return pure path, no filename
#==========================================
    Dir, FN = os.path.split(AFN)
    return Dir

#PURE!
#==========================================
def pureFN(FN):
    return getPureFN(FN)
def getPureFN(AFN): # return pure filename, no path, but with suffix
#==========================================
    Dir, FN = os.path.split(AFN)
    return FN

#==========================================
def getPureFN_NoSuffix(AFN): # return pure filename without suffix
#==========================================
    Dir, FN = os.path.split(AFN)
    FN_nosuffix = os.path.splitext(FN)[0]
    return FN_nosuffix

#==========================================
def getBN(PathFN): # = get pure FN without dirs in front and without suffix
#==========================================
    #example: '/home/dom/bin/AnyFile.png' -> 'AnyFile')
    Dir, FN = os.path.split(PathFN)
    # split into left part and extension, return left part (may have mutliple dirs!) 
    return os.path.splitext(FN)[0]
   
#==========================================
def getDeepestDir(ADN): #get "rightmost" directory in a path
#==========================================
    #('/home/dom', 'bin'), return 'bin'
    return os.path.split(ADN)[1] 

#==========================================================================================================================
#===================================================== PATH MANIPULATION ==========================================================
#==========================================================================================================================
      

#==========================================
def insert_Into_FN_right(FN, NewStr): 
#==========================================
    #produces: Dir1/SomeFileNameStr[NEWSTR].xlsx
    head, suffix = os.path.splitext(FN)
    return head + NewStr + suffix

# formerly: prependFN
#==========================================
def insert_Into_FN_left(FN, MyStr):
#==========================================
    #produces: Dir1/SomeFileNameStr[NEWSTR].xlsx
    Dir, BN, Suffix = split_into_Path_BN_Suffix(FN)
    return Dir + "/" + MyStr + BN + Suffix

#==========================================
def add_To_FN_Before_Dir(FN, Prefix): # add a prefix string to an FN in an AFN
#==========================================
    #produces: Dir1/SomeFileNameStr[NEWSTR].xlsx
    Dir, BN, Suffix = split_into_Path_BN_Suffix(FN)
    return Dir + "/" + Prefix + BN + Suffix      

#==========================================
def removeSuffix(ADN): 
#==========================================
    return os.path.splitext(ADN)[0]  

#==========================================
def nosuffix(ADN): 
#==========================================
    return removeSuffix(ADN)

#==========================================
def escapeSpaces(FN): 
#==========================================
    return FN.replace(" ", r"\ ")  

#will also create the new subdir and change the suffix
#==========================================
def insertSubdir(AFN, DirName, Suffix): 
#==========================================
    Dir, FN = os.path.split(AFN)
    NewAbsDir = Dir + "/" + DirName
    createDir(NewAbsDir)
    NewAFN = NewAbsDir + "/" + getBN(AFN) + Suffix
    return NewAFN 

#==========================================
def replaceDir(AFN, NewDirName): 
#==========================================
    Dir, FN = os.path.split(AFN)
    return NewDirName + "/" + FN

#==========================================================================================================================
#===================================================== FILE PATHES ==========================================================
#==========================================================================================================================

#AFN: absolute filename



#==========================================
def getDirOfGivenFile_withRelCorrection(FN = __file__): 
#==========================================
    # works perfectly, but reaaaallly long...
    return os.path.realpath(os.path.dirname(os.path.realpath(FN)) + "/..")

#==========================================
def getDirOfGivenFile(FN = __file__): 
#==========================================
    #interesting especially for general header
    #but: adding "../" complicates everything (ohnoez)
    return os.path.dirname(os.path.realpath(FN))

#==========================================
def getPureFNOfGivenFile(FN): # return pure filename, no path, but with suffix
#==========================================
    Dir, FN = os.path.split(FN)
    return FN

#==========================================
def getDir(AFN): # return Dir of File
#==========================================
    Dir, FN = os.path.split(AFN)
    return Dir

#==========================================
def split_Dir_FN(AFN): # split into Dir and FN
#==========================================
    Dir, FN = os.path.split(AFN)
    return Dir, FN

#==========================================
def split_into_Path_BN_Suffix(AFN): # return Dir, BN, Suffix
#==========================================
    #In:  /home/dom/Desktop/Vocabulary/vocab_taekwondo.txt
    #Out: /home/dom/Desktop/Vocabulary vocab_taekwondo .txt
    Dir, FN = os.path.split(AFN)
    BN, Suffix = os.path.splitext(FN)
    return Dir, BN, Suffix 

#==========================================
def separateDirPath(ADN): 
#==========================================
    #e.g.: /home/dom/bin gets ('/home/dom', 'bin')
    ParentDir, DirName = os.path.split(ADN)
    return ParentDir, DirName

#==========================================
def splitExamples():
#==========================================  
      
    Dir, File = res("~/bin"), res("~/bin/AnyFile.png")
      
    print "os.path.splitext(Dir):\n", os.path.splitext(Dir)
    print "os.path.split(Dir):\n", os.path.split(Dir)
    print "os.path.splitdrive(Dir):\n", os.path.splitdrive(Dir)
    
    print "os.path.splitext(File):\n", os.path.splitext(File) #for files: gets extension
    print "os.path.split(File):\n", os.path.split(File)
    print "os.path.splitdrive(File):\n", os.path.splitdrive(File)
    
    # RESULT:
#     os.path.splitext(Dir):
#     ('/home/dom/bin', '')
#     os.path.split(Dir):
#     ('/home/dom', 'bin')
#     os.path.splitdrive(Dir):
#     ('', '/home/dom/bin')
#     os.path.splitext(File):
#     ('/home/dom/bin/AnyFile', '.png')
#     os.path.split(File):
#     ('/home/dom/bin', 'AnyFile.png')
#     os.path.splitdrive(File):
#     ('', '/home/dom/bin/AnyFile.png')


        
#==========================================
def splitPathFN(PathFN): 
#==========================================
    # Split the pathname path into a pair, (head, tail) where tail is the last
    # pathname component and head is everything leading up to that
    Dir, FN = os.path.split(PathFN)
    BN = os.path.splitext(FN)[0]
    DIRBN = Dir + "/" + BN
    Tuple = (FN, BN, Dir, DIRBN, PathFN)  #DIRBN = Dir + BN
    #print Tuple
    return Tuple


#==========================================
def getBN_withDirs(PathFN): #Path + Filename without suffix
#==========================================
    Dir, FN = os.path.split(PathFN)
    return Dir + "/" + os.path.splitext(FN)[0]

#==========================================
def getSuffix(PathFN): 
#==========================================
    Dir, FN = os.path.split(PathFN)
    return os.path.splitext(FN)[1]

#==========================================
def getAbsPath(RelativePath): # USE ME
#==========================================
    return os.path.abspath(RelativePath) 

#==========================================
def getAbsPath2(RelativePath): #resolves sym links too... not necessary
#==========================================
    return os.path.abspath(os.path.realpath(RelativePath))

#==========================================
def get_AbsPath_of_File(FN): #GET ABSOLUTE, BEST, EPIC FILEPATH WITHOUT PROBLEMS
#==========================================
    #use e.g. with __file__
    return os.path.abspath(os.path.dirname(os.path.realpath(FN)))



#==========================================================================================================================
#====================================================  FILESYSTEM  ========================================================
#==========================================================================================================================

#best example in town!
#==========================================
def example_os_walk(BaseDir, Patterns = "*.*"): #returns a stdout tree
#========================================== 
    stdout = ""
    for Dir, SubDirs, Files in os.walk(BaseDir):
        SubDirs.sort()  #in-place sort, next yield will yield a yield ehm sorted dirs

        RelDir = Dir.replace(BaseDir + "/", "")
        stdout += RelDir + "\n"
        
        for Pattern in Patterns.split():
            for FN in glob.glob(os.path.join(Dir, Pattern)): 
                RelFN = FN.replace(BaseDir + "/", "")
                stdout += "   |--" + RelFN + "\n"
    return stdout

#==========================================
def globFiles(SearchDir, Pattern):
#==========================================        
    import glob
    FNs = glob.glob(SearchDir + "/" + Pattern) #FNs will have SearchDir as Prefix
    return FNs

#==========================================
def sort_FNs(FNs, mode="Time", reverse=False): #biggest first
#==========================================
    #sort: ascending in print order
    if mode=="Time":
        key = os.path.getmtime # OLDEST AT TOP
    if mode=="Size":
        key = os.path.getsize # SMALLEST AT TOP
    if mode=="Name":    
        key = key=str.lower # "A" AT TOP
    return sorted(FNs, key=key, reverse=reverse)


#==========================================
def getDirContent(ADN):
#========================================== 
    return os.listdir(ADN)

#==========================================
def assertFileExists(FN):
#==========================================   
    assert os.path.isfile(FN), "MISSING FILE: %s (CWD: %s)" % (FN, getCWD())
    
#==========================================
def assertDirExists(Path):
#==========================================   
    assert os.path.isdir(Path), "MISSING DIR: %s (CWD: %s)" % (Path, getCWD())

#==========================================
def checkFileExists(FN):
#==========================================  
    return os.path.isfile(FN)

#==========================================
def notPresent(FN):
#==========================================  
    return not os.path.isfile(FN)

#==========================================
def present(FN):
#==========================================  
    return os.path.isfile(FN)

#==========================================
def exists(FN):
#==========================================  
    return os.path.isfile(FN)

#==========================================
def isMissing(FN):
#==========================================  
    return not os.path.isfile(FN)

#==========================================
def changeDir(ToDir): #returns old dir for convenience
#==========================================
    OldDir = os.getcwd()
    assert os.path.isdir(ToDir), "Missing dir: " + ToDir
    os.chdir(ToDir) 
    print "Changed dir, current working dir: " + os.getcwd()
    return OldDir
 
#==========================================
def changeFromTo(FromDir, ToDir):
#==========================================
    FromDir = os.path.realpath(FromDir) 
    ToDir   = os.path.realpath(ToDir)   
    assert os.path.isdir(FromDir), FromDir
    assert os.path.isdir(ToDir), ToDir
    os.chdir(FromDir)
    print "Previous working dir: " + os.getcwd()
    os.chdir(ToDir)
    print "Current working dir: " + os.getcwd()
    print "Successfully changed to " + os.getcwd()
    

#==========================================
def res(Dir):
#==========================================
    return os.path.expandvars(os.path.expanduser(Dir))

#==========================================
def getCWD(): #get current dir, CurDir
#==========================================
    return os.getcwd()
 
#==========================================
def get_DirInfo_RunDir(RunDir_ADN): 
#==========================================
    DirInfo = {}
    Left, DirInfo["Run_SDN"] = os.path.split(RunDir_ADN) #SDN: single dir name
    Left, DirInfo["Exe_SDN"] = os.path.split(Left)
    DirInfo["BasePath"] = Left
    #pprint(DirInfo)
    return DirInfo

#==========================================
def get_Filesize_in_MB(FN): 
#==========================================
    return os.path.getsize(FN) / 1024 /1024

#==========================================
def chmod_make_executable(FN): # change execution rights / file mods
#==========================================
    st = os.stat(FN)
    os.chmod(FN, st.st_mode | stat.S_IEXEC)

#==========================================================================================================================
#============================================= FILE COPY, MOVE, DEL  ======================================================
#==========================================================================================================================

#==========================================
def rsync_copy(SourceDir, TargetDir, ExcludeWildcards = [], DryRun = False):
#========================================== 
    ExcludeWildcardsStr = " --exclude=" + " --exclude=".join(ExcludeWildcards)
    print "RSYNC ExcludeWildcardsStr:" , ExcludeWildcardsStr
    
    DryRunStr = " --dry-run " if DryRun else ""
    
    assert SourceDir.endswith("/") #no experiments
    assert TargetDir.endswith("/") #no experiments
    
    rsync_cmd = 'rsync %s -av %s "%s" "%s" ' % (DryRunStr, ExcludeWildcardsStr, SourceDir, TargetDir)
    runCmd(rsync_cmd)
    

#==========================================
def copy_to_PlotExamples(AFN):
#========================================== 
    #prepare for print: convert {*.jpg,*.png} PlotExamples.pdf

    TargetDir = ProjectDir + "/DEV/PlotExamples"
    if not os.path.isdir(TargetDir): # doesn't seem like us
        return # do nothing
    CallerName, CurFuncName = get_Stack_Info(Depth = 2) #hack
    FN = getPureFN(AFN)
    copyFile(AFN, TargetDir +  "/FUNCNAME_" + CurFuncName + "_---_" + FN)
    print "Copied to HARP_Core/DEV/PlotExamples: " + FN

#==========================================
def copy_to_SubDir(AFN, SubDirName): #creates a duplicate in a subdirectory (simple!)
#========================================== 
    tmpDir, tmpFN = split_Dir_FN(AFN)
    TargetDir = tmpDir + "/" + SubDirName
    createDir(TargetDir)
    copyFile(AFN, TargetDir + "/" + tmpFN)
    

#==========================================
def copyFile(SrcFN, DstFN):
#==========================================      
    shutil.copyfile(SrcFN, DstFN)

#==========================================
def copyFile2Dir(SrcFN, DstDir): #best for Dropbox jo
#==========================================     
    createDir(DstDir) # must exist
    #DstDir += "/" #if no trailing slash, its interpreted as a file name 
    shutil.copy(SrcFN, DstDir) #note: also works for files, simplify the above
#     NewAbsFN = DstDir + "/" + getPureFN(SrcFN)
#     NewAbsFN = get_AbsPath_of_File(NewAbsFN)
#     return NewAbsFN
   
#==========================================
def copyDir(SrcDir, DstDir):
#==========================================          
    import distutils
    #shutil.copytree(SrcDir, DstDir)  #do no use, will throw error on existing Dst
    distutils.dir_util.copy_tree(SrcDir, DstDir)
    
    #OLD:
    #shutil.dir_util.copy_tree(SrcDir, DstDir)
    
#==========================================
def copyDirToParent(SrcDir, ParentDstDir):
#==========================================          

    # without the need to fiddle with dst directory names...
    # it does not matter if ParentDstDir has "/" at end
    cmd  = "cp -r \"%s\" \"%s\" " % (SrcDir, ParentDstDir)
    runCmd(cmd)

#==========================================
def moveFile(SrcFN, DstFN): # same as rename
#==========================================      
    assert not os.path.isdir(SrcFN)
    assert not os.path.isdir(DstFN)
    shutil.move(SrcFN, DstFN)  

#==========================================
def deleteDir(DirName): #remove dir, removedir
#========================================== 
    if os.path.exists(DirName):
        print "WARNING: deleting " + DirName
        #askUser()
        shutil.rmtree(DirName)
        
#==========================================
def deleteFile(FN):
#==========================================
    if os.path.isfile(FN):       
        os.remove(FN)
        
#==========================================
def deleteFiles(DirPath, Wildcard, dryrun=False):
#==========================================
    for FN in glob.glob(os.path.join(DirPath, Wildcard)):
        if dryrun:
            print "WOULD delete file (dryrun):", FN     
        else:
            os.remove(FN)

#==========================================
def createDir(DirName):
#==========================================         
    if not os.path.exists(DirName):
        os.makedirs(DirName)   
    return DirName

#==========================================================================================================================
#==================================================  FILE IO  =============================================================
#==========================================================================================================================
    
#==========================================
def get_File_Content(FN):
#==========================================
    with open(FN, "r") as myfile:
        return myfile.read() #raw read, all into one string
        
#==========================================
def readFromFile(FN):
#==========================================
    with open(FN, "r") as myfile:
        return myfile.readlines() #return list of lines    
    
#==========================================
def getLinesFromFile(FN):
#==========================================
    with open(FN) as f:
        Lines = f.read().splitlines() #splitlines: also remove "\n"
    return Lines
 
#==========================================
def writeToFileNEW(Text, FN): #TBD: optional: encoding='utf-8'  
#==========================================
    with open(FN, "w") as myfile:
        myfile.write(Text)
        
#==========================================
def appendToFileNEW(Text, FN):
#==========================================
    with open(FN, "a") as myfile:
        myfile.write(Text)
    
#==========================================
def writeStringToFN(Text, FN): #optional: encoding='utf-8'  
#==========================================   
    with open(FN, "w") as text_file:
        text_file.write(Text)
        

        
#==========================================
def writeLinesToFN(Lines, FN): #optional: encoding='utf-8'  
#==========================================  
    text_file = open(FN, "w")
    for line in Lines:
        text_file.write(line)
    text_file.close()

#==========================================
def appendToFile(FN, Text):
#==========================================
    with open(FN, "a") as myfile:
        myfile.write(Text)
        
#==========================================
def flush():
#==========================================
    sys.stdout.flush()  

#==========================================
def writeToFile(FN, Text): #TBD: optional: encoding='utf-8'  
#==========================================
    with open(FN, "w") as myfile:
        myfile.write(Text)
    
#DEPRECATED
#==========================================
def readText_UTF8(FN): 
#==========================================
    return readTXT(FN)

#DEPRECATED
#==========================================
def writeTextToFN_UTF8(Text, FN):
#==========================================   
    writeTXT(Text, FN)


#==========================================
def readTXT(FN, encoding='utf-8'): 
#==========================================
    f = codecs.open(FN, "r", encoding)
    UnicodeStr = f.read()
    return UnicodeStr

#==========================================
def writeTXT(String, FN, encoding='utf-8', silent=False): 
#==========================================
    f =  codecs.open(FN, "w", encoding=encoding)
    f.write(String)
    if not silent: print "Written to: %s" % (FN)
    f.close()
    
#==========================================
def appendTXT(String, FN, encoding='utf-8', silent=False): 
#==========================================
    f =  codecs.open(FN, "a", encoding=encoding)
    f.write(String)
    if not silent: print "Written to: %s" % (FN)
    f.close()
    


#OLD. REMOVE
# #==========================================
# def logText(Text, FN):
# #==========================================
#     with open(FN, "a+") as text_file:
#         text_file.write(Text + "\n")
        
#==========================================
def log(Text, LogFN = "log.txt"): #UTF8 compatible
#==========================================
    with codecs.open(LogFN, "a+", encoding="utf-8") as text_file:
        #if Text != "":
        text_file.write(Text + "\n")
        print Text
                
#==========================================
def clearlog(LogFN = "log.txt"):
#==========================================
    with codecs.open(LogFN, "w", encoding="utf-8") as text_file:
        text_file.write("")
        


#==========================================================================================================================
#============================================== DEBUGGING / LOGGING =======================================================
#==========================================================================================================================


#==========================================
def print_PYTHONPATH():
#==========================================
    print "PYTHONPATH: "
    pprint(sys.path)

#==========================================
def openMeld(FN1, FN2):
#==========================================
    # use meld before removing hyphons
    cmd = 'meld "%s" "%s"' % (FN1, FN2)
    print runCmd(cmd)

#==========================================
def printscope():
#==========================================
#warning: only use direct, OR: get parent scope here (TBD)
    for symbol, value in locals().items():
        print symbol, value

#OLD! REMOVE!
# #==========================================
# def log(Text, FN):
# #==========================================
#     with open(FN, "a") as myfile:
#         myfile.write(Text + "\n")

#==========================================
def is_ShallowStack(): #we use this for detection of C++ 2 Python calls
#========================================== 
    #note: the current function is always at StackFuncs[0], so its "on top"
    import inspect
    StackFuncs = inspect.stack()
    for Func in StackFuncs:
        print "StackFunc: ", Func[3]
    return True if len(StackFuncs) == 2 and StackFuncs[0][3] == "is_ShallowStack" else False

#==========================================
def get_Stack_Info(Depth = 1):
#========================================== 
    import inspect
    StackInfo = inspect.stack()
    CallerName, CurFuncName = StackInfo[1+Depth][3], StackInfo[0+Depth][3]
    return CallerName, CurFuncName
                    
#==========================================
def get_StackTrace(): #get Backtrace / Traceback 
#==========================================
    import traceback
    from cStringIO import StringIO
    buffer = StringIO()
    traceback.print_stack(file=buffer)
    Stacktrace = buffer.getvalue()
    buffer.close()
    return Stacktrace

# get object type / object class
#==========================================
def getType(object):
#==========================================  
    print "Type: ", type(object)

#==========================================
def playSound():
#==========================================  
    os.system('mplayer /home/dom/bin/alert.wav \&> /dev/null')
    #os.system('mplayer /home/dom/bin/alert.wav \&> /dev/null')
    #os.system('mplayer /home/dom/bin/alert.wav \&> /dev/null')
    print_Current_DateTime()

#==========================================
def get_Random_Int_Between(Min=0, Max=9):
#==========================================    
    import random
    return random.randint(Min,Max)
    
#==========================================
def is_Eclipse_Debugger():
#==========================================
    # WORK IN PROGRESS

    #bad idea: backtrace only for current thread (Run: only one entry)
    CurFrames = sys._current_frames()
    FirstFrame = CurFrames[sorted(CurFrames.keys())[0]]
    Filename = FirstFrame.f_code.co_filename
    print Filename
    isEclipseDebugger = True if "pydevd" in Filename else False
    print "Number of frames: ", len(CurFrames)
    for Key in CurFrames.keys():
        print "\t" + CurFrames[Key].f_code.co_filename

    #better
    import inspect
    CurFrames = inspect.stack()
    print "Number of frames: ", len(CurFrames)
    for Frame in CurFrames:
        print "\t" + Frame[1] 

#==========================================================================================================================
#====================================================   TIME / TIMINGS ====================================================
#==========================================================================================================================

#==========================================
def get_Date_From_String(String, FormatStr = "%Y-%m-%d"): #autodetect from other "date" stdout
#==========================================    
    import dateutil.parser
    yourdate = dateutil.parser.parse(String)              
    DateStr = yourdate.strftime(FormatStr)
    return DateStr
    
#==========================================
def get_Time_Str(withSecs=False):
#==========================================
    if not withSecs:
        return datetime.datetime.now().strftime("%Y-%m-%d %H:%M")
    else: return datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")

#==========================================
def get_Start_Time(walltime = False): #measure "process" time (=CPU time, not wall time)
#==========================================
    return time.time() if walltime else time.clock()

#==========================================
def since(StartTime, walltime = False): #measure "process" time (=CPU time, not wall time)
#==========================================
    return time.time() - StartTime if walltime else time.clock() - StartTime

#==========================================
def print_Seconds(secs):
#==========================================
    print "Elapsed time: %0.3f secs  (= %0.1f minutes)" % (secs, secs / 60)

#==========================================
def sleep(Secs):
#==========================================
    time.sleep(Secs) 

#==========================================
def get_Seconds_since_Midnight():
#==========================================    
    firstsecofday = datetime.datetime.combine(datetime.date.today(), datetime.time.min)
    now = datetime.datetime.now()
    AbsSecs = int((now - firstsecofday).total_seconds())
    #print "Seconds since midnight: ", AbsSecs
    return AbsSecs

#==========================================
def get_Current_DateTime():
#==========================================
    return datetime.datetime.now()

#==========================================
def get_Minutes_and_Seconds():
#==========================================
    tm = datetime.datetime.now()
    return tm.minute, tm.second


#==========================================
def print_Current_DateTime():
#==========================================
    tm = datetime.datetime.now()
    print "Current date and time:"
    print str(tm)
    print tm.strftime("%Y-%m-%d %H:%M")
    #print tm.isoformat()
    #example:
    year, month, day, hour, minute, second, microsecond = tm.year, tm.month, tm.day, tm.hour, tm.minute, tm.second, tm.microsecond

#==========================================================================================================================
#====================================================  EPIC DICT BROWSER  =================================================
#==========================================================================================================================

#Use: Dict_Browser().show("My.hdt")
#==========================================
def browse_Dict(MyDict, Title=""):
#==========================================
    try:
        from traits.api import HasTraits, Instance
        from traitsui.api import View, VGroup, Item, ValueEditor
           
        #|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
        class Dict_Browser(HasTraits): #Enables any Python class derived from HasTraits to have trait atttributes
        #|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
    
            #=========================    
            def __init__(self, Dict):
            #=========================
                super(Dict_Browser, self).__init__()
                self.Dict = Dict
    
            #=========================    
            def trait_view(self, name=None, view_elements=None):
            #=========================
                MyGroup = VGroup(Item( 'Dict',
                          label      = 'Dict',
                          show_label = True,
                          style      = 'simple',
                          dock       = 'horizontal',
                          editor     = ValueEditor(),),)
            
                return View(
                  MyGroup,
                  title     = Title,
                  width     = 1280,
                  height    = 800,
                  resizable = True
                )
                
        Browser = Dict_Browser(MyDict)
        Browser.configure_traits() #Creates and displays a dialog box for editing values of trait attributes
        
    except:
        print "Sorry, Traits API not supported."
        pass

#==========================================================================================================================
#================================================== DEEP COPIES  ==========================================================
#==========================================================================================================================


#==========================================
def dc(Obj):
    return deepcopy(Obj)
def deepcopy(Obj): # use this to be safe (built-in methods do no deep-copy lists etc. in dicts!)
#==========================================
    import copy
    #return copy.copy(obj)     # shallow copy
    return copy.deepcopy(Obj)  # deep (recursive) copy

#==========================================
def deepcopy_sequence(Sequ): 
#==========================================
    return Sequ[:] #just slice ALL

#do not use!
#==========================================
def deepcopy_dict(Dict):
#==========================================
    return Dict.copy() #Dictionaries have a copy method #CAREFULL!!! WILL NOT DEEP-COPY LISTS AND SO, DANGEROUS!!

#do not use!
#==========================================
def deepcopy_List_Dict(List, Dict, Set, Tuple): # probably same problem as Dict.copy()
#==========================================
    return list(List), dict(Dict), set(Set), tuple(Tuple) #alternative: use explicit constructor

#==========================================================================================================================
#====================================================   OTHER  ============================================================
#==========================================================================================================================

#==========================================
def get_CPUInfo():
#==========================================
    import Regex
    RetStr = runCmd_getStdoutStderr('cat /proc/cpuinfo')
    res_tuple = Regex.regex_getGroups(RetStr,r"model name\t: (.*)" )
    return res_tuple[0]    


#==========================================
def shutdownPC(Minutes=1): #CAREFULL
#==========================================
        # does not work
#         import os
#         cmd = 'sudo -S ls "/home/dom/.config/enchant" >> %s/Test.txt' % CoreTmpDir
#         print cmd
#         os.popen(cmd, 'w').write("asdgfdf")

        # Strange. Could get this dude to work        
        #os.popen("sudo -S %s"%(command), 'w').write('mypass')        
        
        #using os.system, tty problem from eclipse can be circumvented
        pw = str(readTXT("/home/dom/bin/pw.txt"))
        #Debug:
        #command = 'ls "/home/dom/.config/enchant" > %s/Test.txt' % CoreTmpDir
        command = 'shutdown -h +%d ' % Minutes
        print "sudo command: ", command
        p = os.system('echo %s|sudo -S %s' % (pw, command))
        
#==========================================
def existsGobal(name):
#==========================================
    return name in __builtins__          # built-in
     
#==========================================
def existsInContext(name):
#==========================================
    return (name in sys._getframe(1).f_locals  # caller's locals
         or name in sys._getframe(1).f_globals # caller's globals
         or name in __builtins__)          # built-in
                 
#==========================================
def loadModule(FN, ModuleName='Metainfo'): # dynamic loading of source files
#==========================================   
    #Oh yes! We can simply pull in all settings by the little trick below  
    import imp
    TmpModule = imp.load_source(ModuleName, FN)
    return TmpModule

# Idx1 = enum('NAME', 'ENCBIN', 'DECBIN', 'INI', 'PSNR', 'OVERRIDE', 'INFOSTR')
#==========================================
def enum(*sequential, **named):
#==========================================
    enums = dict(zip(sequential, range(len(sequential))), **named)
    return type('Enum', (), enums)

#==========================================
def simpleThread(myfunc, args):
#==========================================
    import threading
    print "Detaching simple thread"
    import copy
    args = copy.deepcopy(args)
    MyThread = threading.Thread(target=myfunc, args=args)
    MyThread.daemon = False
    MyThread.start()

#deprecated
#==========================================
def runCall(Call):
#==========================================
        print "Running: \n" + Call
        flush()
        assert os.system(Call) == 0, "Call returned error:" + Call 

        #ALTERNATIVE: via POPEN
#         process = subprocess.Popen(Call, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE) 
#         for line in iter(process.stdout.readline, b''):
#             sys.stdout.write(line)

#==========================================
def runCall_2(Call):
#==========================================
    print "Running: \n" + Call
    pipe = os.popen(Call, 'r',0)
    stdout = pipe.read() #also stderr?
    #print stdout
    
    #not working
#     retval = pipe.close()
#     print retval
#     if retval != 0:
#         print stdout
#         assert 0, "Call returned error: " + Call
    return stdout

#Run command with arguments and return its output as a byte string.

#==========================================
def runCmd(cmd, silent = False):
#==========================================
    if not silent: print "Running cmd: \n" + cmd
    sys.stdout.flush() 
    assert os.system(cmd) == 0, "Cmd returned error:" + cmd 

#WORKS PERFECTLY (no sign of lost stderr)
#==========================================
def runCmd_getStdoutStderr(cmd):
#==========================================
    import subprocess
    print "Running CMD: \n" + cmd
    arglist = ["/bin/bash", "-c", cmd]
    settings = dict(stderr=subprocess.STDOUT, shell=False) #shell== True-> nothing happens (?)
    OutputStr =  subprocess.check_output(arglist, **settings).decode("utf-8")
    return OutputStr

#USE THIS! This will not break in case of non-zero exit code!
#==========================================
def runCmd_getStdoutStderr_NEW(cmd):
#==========================================
    import subprocess
    print "Running CMD: \n" + cmd
    arglist = ["/bin/bash", "-c", cmd]
    settings = dict(stderr=subprocess.STDOUT, shell=False) #shell== True-> nothing happens (?)
    
    try:
        OutputStr =  subprocess.check_output(arglist, **settings).decode("utf-8")
        ErrCode = 0
    except subprocess.CalledProcessError as grepexc:                                                                                                   
        print "ERROR!!! Call returned error: ", grepexc.returncode, grepexc.output
        OutputStr = grepexc.output
        ErrCode = grepexc.returncode
        
    return OutputStr, ErrCode
        
#==========================================
def runCmd_getPID(cmd):
#==========================================
    popenobj = subprocess.Popen(["/bin/bash", "-c", cmd])
    PID = popenobj.pid
    
#==========================================
def get_MD5_Sum(FN):  
#==========================================
    import hashlib
    return hashlib.md5(open(FN, 'rb').read()).hexdigest()

#==========================================
def get_Cmdline_Args():  # argc, argv
#==========================================
    for idx, arg in enumerate(sys.argv):
        print "Command line arg %d: %s" % (idx, arg)
    return sys.argv

#==========================================
def assertToolsExist(Tools):
#==========================================
    for Tool in Tools:
        assert os.system(Tool + " --help > /dev/null") == 0, Tool + " not found"

#==========================================
def forceRunInScreen():
#==========================================
    #we check if we run inside screen
    try:
        STY = str(os.environ['STY'])
    except:
        STY = "" 
    assert STY != "", "NOT RUNNING IN SCREEN."
    
#==========================================
def assertCMakeVersion_2_8():
#==========================================
    CMakeVersion = os.popen('cmake --version').read()
    assert ("2.8" in CMakeVersion), "CMake version not 2.8, but: " + CMakeVersion
 

#==========================================
def getUser():
#==========================================
    import getpass
    return getpass.getuser()
        
#==========================================
def setEnvironmentVar(VarName, Content):
#==========================================    
    if not os.getenv( VarName ):
        os.environ[VarName] = res(Content) 
    else:        
        os.environ[VarName] = res(Content) + ":" + os.environ[VarName]
    
#==========================================
def askUser():
#==========================================  
    print "Is this ok? yes/no"
    yes = set(['yes','y', ''])
    no = set(['no','n'])

    choice = raw_input().lower()
    if choice in yes:
        return True
    elif choice in no:
        return False
    else:
        return askUser()
    
#==========================================
def pressAnyKey():
#========================================== 
    assert(0) # DOES NOT BLOCK WHEN CALLED FROM PYTHON. WHY??
    os.system('read -p "Press any key..."')
    
#||||||||||||||||||||||||||||||||||||||||||||||||||
class CLock:
#||||||||||||||||||||||||||||||||||||||||||||||||||
    
    #==========================================
    def __init__(self, FN):
    #==========================================
        self.FN = FN
        self.handle = open(FN, 'w') #create it if it does not exist

    #==========================================
    def acquire(self):
    #==========================================
        #print "Locking..."
        lockdata = struct.pack('hhllhh', fcntl.F_WRLCK, 0, 0, 0, 0, 0)
        fcntl.fcntl(self.handle.fileno(),fcntl.F_SETLKW, lockdata)
      
    #==========================================  
    def release(self):
    #==========================================
        fcntl.lockf(self.handle.fileno(), fcntl.LOCK_UN)        

    #==========================================
    def __del__(self):
    #==========================================
        self.handle.close()

#==========================================
# COLORS OPENCV
#==========================================
#as numpy arrays for easy flipping

# use: print colornames2BGR(('yellow', 'cyan'))
#==========================================
def colornames2BGR(colornames): #warning! BGR!
#==========================================
    import matplotlib
    cnames = matplotlib.colors.cnames
    ListofLists = []
    for colorname in colornames:
        hex = cnames[colorname][1:]
        scaling = 1.0 #255
        RGB =  list([int(hex[i:i + 2], base=16) / float(scaling) for i in [0, 2, 4]]) 
        BGR = RGB[::-1]
        ListofLists.append(BGR)
    return ListofLists

# ATTENTION: BRG (-> OpenCV)
WHITE       = [255, 255, 255]
GRAY        = [127, 127, 127]
DARKGRAY    = [64, 64, 64]
BLACK       = [0, 0, 0]
DARKGREEN   = [0, 64, 0]
MEDIUMGREEN = [0, 128, 0]
YELLOW      = [0, 255, 255]
DARKRED     = [0, 0, 64]
DARKBLUE    = [64, 0, 0]
DARKORANGE  = [0, 140, 255]
OLIVE       = [0,128,128]
BRBA_BLUE   = [194,189,44]
BRBA_RED    = [52,97,220]
BRBA_GREEN  = [63,168,125]

RED         = [0, 0, 255]
BLUE        = [255, 0, 0]
GREEN       = [0, 255, 0]
BRBA_YELLOW = [13, 201, 250]
IntraColor = RED
InterColor = BLUE
MergeColor = GREEN
SkipColor  = BRBA_YELLOW #MEDIUMGREEN
ORANGE = colornames2BGR(('darkorange',))[0]
CYAN = colornames2BGR(('cyan',))[0]

# 
#RefIdcsColors = YELLOW, GREEN, BLUE, RED, OLIVE, YELLOW, GREEN, BLUE, RED, OLIVE
RefIdcsColors = colornames2BGR(('cyan', 'violet', 'chocolate', 'yellow'))
#RefIdcsColors = colornames2BGR(('white', 'white', 'white', 'yellow'))

#ResiLimits = -16.0, +16.0
ResiLimits = -8.0, +8.0

'yellow', 'magenta', 'cyan', 'brown'

#==========================================
# COLORS MATPLOTLIB
#==========================================
# ATTENTION! Using these colors for matplotlib requires flipping to RGB:
GREEN_RGB = GREEN[::-1]
BLUE_RGB  = BLUE[::-1]
RED_RGB   = RED[::-1]


#==========================================
# LUTS
#==========================================
truestr = { 0: "False", 1: "True"}

#==========================================
def scaleColors(From): # flip, scale to [0,1]
#==========================================
    ToColors = []
    for FromColor in From:
        ToColor = np.asarray(FromColor[::-1]) / 255.0
        ToColors.append(ToColor)
    return ToColors

ExampleColorList = scaleColors( (IntraColor, InterColor, MergeColor, SkipColor, GRAY) )

#==========================================
def scaleColor(From): # flip, scale to [0,1]
#==========================================
    ToColor = np.asarray(From[::-1]) / 255.0
    return ToColor
#-
#==========================================
# SHELL COLORS (NOTE: MAY SHOW BUGS)
#==========================================
class cmdcolor: 
    
    # Regular Colors
    Black='\033[0;30m'        # Black
    Red='\033[0;31m'          # Red
    Green='\033[0;32m'        # Green
    Yellow='\033[0;33m'       # Yellow
    Blue='\033[0;34m'         # Blue
    Purple='\033[0;35m'       # Purple
    Cyan='\033[0;36m'         # Cyan
    White='\033[0;37m'        # White
    
    # Bold
    BBlack='\033[1;30m'       # Black
    BRed='\033[1;31m'         # Red
    BGreen='\033[1;32m'       # Green
    BYellow='\033[1;33m'      # Yellow
    BBlue='\033[1;34m'        # Blue
    BPurple='\033[1;35m'      # Purple
    BCyan='\033[1;36m'        # Cyan
    BWhite='\033[1;37m'       # White
    
    # Underline
    UBlack='\033[4;30m'       # Black
    URed='\033[4;31m'         # Red
    UGreen='\033[4;32m'       # Green
    UYellow='\033[4;33m'      # Yellow
    UBlue='\033[4;34m'        # Blue
    UPurple='\033[4;35m'      # Purple
    UCyan='\033[4;36m'        # Cyan
    UWhite='\033[4;37m'       # White
    
    # Background
    On_Black='\033[40m'       # Black
    On_Red='\033[41m'         # Red
    On_Green='\033[42m'       # Green
    On_Yellow='\033[43m'      # Yellow
    On_Blue='\033[44m'        # Blue
    On_Purple='\033[45m'      # Purple
    On_Cyan='\033[46m'        # Cyan
    On_White='\033[47m'       # White
    
    # High Intensity
    IBlack='\033[0;90m'       # Black
    IRed='\033[0;91m'         # Red
    IGreen='\033[0;92m'       # Green
    IYellow='\033[0;93m'      # Yellow
    IBlue='\033[0;94m'        # Blue
    IPurple='\033[0;95m'      # Purple
    ICyan='\033[0;96m'        # Cyan
    IWhite='\033[0;97m'       # White

    End = '\033[0m'
#-

#==========================================
# MERGEME! MERGEME! MERGEME! 
#==========================================

#==========================================
if __name__ == '__main__':
#==========================================
    print "RefIdcsColors: ", RefIdcsColors
    