#!/usr/bin/env python
# coding: utf8
# (c) 2014 Dominic Springer
# This file is licensed under the 2-Clause BSD License (see HARP_License.txt)

import os
import sys
import os.path
import numpy as np
import codecs
import re
import pickle
import cPickle
import math as m
import time
import datetime
import types
import shutil
import copy
import fileinput
import platform
import stat
import array
import threading 
import struct
import zlib
import ConfigParser
import distutils.dir_util
import marshal
import glob
import traceback
import platform
import collections


from collections import namedtuple



# see General.py for usage instructions
#==========================================
def set_HARP_Core_Environment(AssumedCoreDir, ModuleName): #ModuleName: Trick to switch cases below
#==========================================

    if ModuleName == '__main__':  #make sure we set Environment only from __main__!!!
        
        
        assert "HARP_Core" in AssumedCoreDir, AssumedCoreDir

        #print "Test=", os.path.abspath(get_Path(ModuleFileFN) + "/" + RelPath)
        #sys.exit()
        # ==============================================================================
        # deprecated! Do not longer use!
        # ==============================================================================
        #__builtins__.update(ProjectDir   = os.path.abspath(os.path.dirname(ModuleFileFN) + "/" + RelPath))
        
        __builtins__.update(ProjectDir   = AssumedCoreDir )        # == where HARP_Core is
        __builtins__.update(LibDir       = ProjectDir)           # == where HARP_Core is          #should become: CoreDir
        __builtins__.update(TmpDir       = ProjectDir + "/tmp")  # == where we dump logs etc.     #should become: CoreTmpDir
        __builtins__.update(HARP_ProjectDir  = os.path.abspath(ProjectDir + "/../HARP_Kit") )     #should become: KitDir
        __builtins__.update(HARP_TmpDir      = os.path.abspath(ProjectDir + "/../HARP_Kit/tmp") ) #should become: KitTmpDir
        
        # ==========================
        # THE FOUR ELEMENTAL HARP DIRS
        # ==========================
        __builtins__.update(CoreDir          = AssumedCoreDir) 
        __builtins__.update(CoreTmpDir       = CoreDir + "/tmp")  # == where we dump logs etc.
        __builtins__.update(KitDir           = os.path.abspath(CoreDir + "/../HARP_Kit") )     #should become: KitDir
        __builtins__.update(KitTmpDir        = os.path.abspath(CoreDir + "/../HARP_Kit/tmp") ) #should become: KitTmpDir        
        
        UserSysPath = [ent for ent in sys.path if "/usr/" not in ent ]
        
        print "=== INIT HARP CORE ========================"
        print "ModuleName=", ModuleName
        print "SysPath= ", "\n".join(UserSysPath)
        print ""
        print "CoreDir=    " + CoreDir
        print "CoreTmpDir= " + CoreTmpDir
        print "KitDir=     " + KitDir
        print "KitTmpDir=  " + KitTmpDir
        print ""
        print "LibDir=     " + LibDir
        print "============================================"
        sys.path.extend([ProjectDir, LibDir, LibDir + "/DEV"])  
        assert "HARP_Core" in CoreDir
        assert "HARP_Kit"  in KitDir
        
        #DELETE LATER
        #assumption is: we are under [...]/HARP_Core
        #if not, set HC_RelPath
        #assert "HARP_Core" in os.path.basename(ProjectDir), "FALSE ProjectDir: " + ProjectDir
        
        #not required for HARP_Core
        #assert os.path.isdir(HARP_ProjectDir), "FALSE HARP_ProjectDir: " + HARP_ProjectDir
        #assert os.path.isdir(HARP_TmpDir), "FALSE HARP_TmpDir: " + HARP_TmpDir  #breaks RC-Curve script
    
        # OLD, DO NOT LONGER USE!
#         if __name__ == '__main__':
#             import sys, os
#             __builtins__.ProjectDir = os.path.abspath(os.path.dirname(os.path.realpath(__file__)) + "/..") # == where we reside
#             __builtins__.LibDir = ProjectDir             # == where HARP_Core is
#             __builtins__.TmpDir = ProjectDir + "/tmp"    # == where we dump logs etc.  | meas: "/../.."
#             assert( "HARP" in os.path.basename(ProjectDir) ), "ProjectDir=" + ProjectDir
#             sys.path.extend([ProjectDir, LibDir, LibDir + "/DEV"])

# now we can play!
from General import *
