#!/usr/bin/env python
# coding: utf8
# (c) 2014 Dominic Springer
# This file is licensed under the 2-Clause BSD License (see HARP_License.txt)

from Imports_Basic import *
from Plot import *

import thread
from Pandas import *
from threading import Thread, Lock

mutex = Lock()
keepRunning = True
MyThread = None
#==========================================
def start_Ram_Log(PID, FN_XLSX):
#==========================================    
    import psutil
    
    Col_Labels = ["time", "percent", "available", "rss", "vms", "shared", "data", "text", "lib"]

    #if os.path.isfile(FN_XLSX): #exists already
    #    df = load_Dataframe_from_Excel(FN_XLSX)
    #else: #create it!
    
    df = pd.DataFrame(columns = Col_Labels)

    def logRAM(PID, df, Col_Labels):
    #==========================
        try:
            cnt = 0
            
            # Fill with zero lines due to interpolation issues
            for i in np.arange(1,4):
                data = np.array([[0,0,0,0,0,0,0,0,0]])
                s1 = pd.DataFrame(data, index=(get_Seconds_since_Midnight(),), columns=Col_Labels)
                df = df.append(s1)   
                time.sleep(1)
                
            while keepRunning:
                print "======= LOGGING RAM AT " + time.strftime("%H:%M:%S") + "======="
                p = psutil.Process(PID) 
                Info    = p.get_ext_memory_info()
                
                percent   = p.get_memory_percent()
                available = psutil.virtual_memory().available / 1000 / 1000
                rss       = Info.rss / 1000 / 1000
                vms       = Info.vms / 1000 / 1000
                shared    = Info.shared / 1000 / 1000
                data      = Info.data / 1000 / 1000
                text      = Info.text / 1000 / 1000
                lib       = Info.lib / 1000 / 1000

                #s1 = pd.Series([percent,available,rss,vms,shared,data,text,lib])
                #s1.name = get_Seconds_since_Midnight()
                timestr = get_Time_Str()            
                data = np.array([[timestr, percent,available,rss,vms,shared,data,text,lib]])
                
                # -----------------------------
                # APPEND A PANDAS ROW
                # -----------------------------
                # create one-row dataframe (with according index and correct column lables)
                s1 = pd.DataFrame(data, index=(get_Seconds_since_Midnight(),), columns=Col_Labels)
                # append the row
                df = df.append(s1)            
                
                time.sleep(1)
                if cnt % 5 == 0:
                    mutex.acquire()
                    save_DF_to_Excel(df, FN_XLSX, "logRAM")
                    mutex.release()
                    #save_CPickle_FN(df, TmpDir + "/ABMC_64x64.RamInfo")
#                     writer = pd.ExcelWriter(FN_XLSX)
#                     df.to_excel(writer, "logRAM")
#                     writer.save()
                cnt += 1
                
            print "LogRAM thread exited"
            time.sleep(5)  
                
        except Exception, Str:        
            print "EXCEPTION------------------------"
            print "Unexpected ERROR:", sys.exc_info()[0]
            traceback.print_tb(sys.exc_info()[2])
            print Str  
            print "---------------------------------"
            raise

    #thread.start_new_thread( logRAM, (PID, df, Col_Labels) )
    global MyThread
    MyThread = threading.Thread(target=logRAM, args=(PID, df, Col_Labels))
    MyThread.daemon = True
    # Sticks the thread in a list so that it remains accessible
    print "Starting thread"
    MyThread.start()
    
    
#         tmpdf = load_Dataframe_from_Excel(FN_XLSX)
#         tmpdf.plot()
#         plt.show()
 
#==========================================
def plot_RAM_Log(FN_XLSX):
#==========================================    
    mutex.acquire()
    
    # DO NOT ACTIVATE THIS!
    # REENTRANCY PROBLEM
    # PLOTTING WILL OFTEN CRASH WITH:
    # Tcl_AsyncDelete: async handler deleted by the wrong thread

    
#     if os.path.isfile(FN_XLSX): #exists
#         df = load_Dataframe_from_Excel(FN_XLSX)
#         ax = df.plot()
#         fig = ax.get_figure()
#         #plt.show()
#         savePlot_PNG("RamLog.png")
#         fig.clf()
#         plt.close(fig)

    # CURRENT WORKAROUND: call as external process
    

    mutex.release()
    
#==========================================
def stop_RAM_Log():
#==========================================   
    
    global keepRunning
    global MyThread
    keepRunning = False;
    #time.sleep(10)
    
    MyThread.join()
    print "RAM Log stopped" 
    
#==========================================
if __name__ == '__main__':
#==========================================    
    #sys.exit(0)
    
    # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    # DO NOT CHANGE!
    # REQUIRED FOR OPENING XLSX FILES AS GRAPHS
    # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#     import sys, os
#     sys.path.append(os.path.abspath(".."))
#     from PythonLib.Pandas import *

    __builtins__.ProjectDir = os.path.abspath(os.path.dirname(os.path.realpath(__file__)) + "/.." )
    __builtins__.LibDir = ProjectDir + "/PythonLib"
    __builtins__.TmpDir = ProjectDir + "/tmp"
    assert( "HARP" in os.path.basename(ProjectDir) ), ProjectDir
    sys.path.append(LibDir) 
    
    from Imports_Basic import *
    from DataTree import *

    assert(len(sys.argv) == 2), "Usage: [scriptname] File"
    FN_XLSX = os.path.realpath(sys.argv[1])
    
    print "Loading: ", FN_XLSX
    
    if os.path.isfile(FN_XLSX): #exists
        df = load_Dataframe_from_Excel(FN_XLSX)
        df = delete_columns(df, ("percent", "text", "lib", "shared"))
        ax = df.plot()
        fig = ax.get_figure()
        #plt.xlim(0, 8000)
        plt.ylim(ymin=0, ymax=8000)
        savePlot_PNG(TmpDir + "/RamLog.png")
        plt.show()
        fig.clf()
        plt.close(fig)

    
    #OR, AS ONELINER:
    # python -c 'import sys, os; sys.path.append(os.path.abspath("..")); from PythonLib.Pandas import *; plot_RAM_Log("/home/dom/Desktop/Jetson_TK1/HARP/tmp/RamLog.xlsx")'
    
    
